/* BuddyItem.m created by epeyton on Sat 27-Mar-1999 */

#import "BuddyItem.h"

@implementation BuddyItem

NSMutableDictionary *allBuddies;

+ (void)initialize
{
    allBuddies = [[NSMutableDictionary alloc] init];
    return;
}    

+ (BuddyItem *)buddyNamed:(NSString *)aName
{
    return [allBuddies objectForKey:aName];
}    

- (void)dealloc
{
    [buddyName release];
    [super dealloc];
}

- (id)initWithBuddyName:(NSString *)aName
{
    self = [super init];
    [self setBuddyName:aName];
    [allBuddies setObject:self forKey:aName];
    return self;
}

- (NSString *)description
{
    return [self buddyName];
}

- (void)setBuddyName:(NSString *)aName
{
   	[buddyName autorelease];
    buddyName = [aName retain];
    return;
}

- (NSString *)buddyName
{
    return buddyName;
}

- (void)setService:(NSString *)aName
{
   	[service autorelease];
    service = [aName retain];
    if ([service isEqual:AIM_SERVICE]) {
        aim_add_buddy([[self buddyName] cString]);
    }

    return;
}

- (NSString *)service
{
    return service;
}

- (void)prepareForRemoval
{
    if ([service isEqual:AIM_SERVICE]) {
        aim_remove_buddy([[self buddyName] cString]);
    }
    [allBuddies removeObjectForKey:[self buddyName]];
    return;
}

@end
