/* CommunicationController.m created by epeyton on Mon 08-Mar-1999 */

#import "CommunicationController.h"

@implementation CommunicationController

- (id)init
{

	rxcallback_t Maim_callbacks[] = {
    	maim_parse_incoming_im, /* incoming IM */
        maim_parse_oncoming_buddy, /* oncoming buddy */
        maim_parse_offgoing_buddy, /* offgoing buddy */
        maim_parse_missed_im, /* last IM was missed 1 */
        maim_parse_missed_im, /* last IM was missed 2 */
        NULL, /* login phase 4 packet C command 1*/
        NULL, /* login phase 4 packet C command 2 */
        NULL, /* login phase 2, first resp */
        NULL, /* login phase 2, second resp */
        NULL, /* login phase 3 packet B */
        NULL, /* login phase 3D packet A */
        NULL, /* login phase 3D packet B */
        NULL, /* login phase 3D packet C */
        NULL, /* login phase 3D packet D */
        NULL, /* login phase 3D packet E */
        maim_parse_login_phase3d_f, /* login phase 3C packet F */
        maim_parse_snacerror, /* last command bad */
        maim_parse_missed_im, /* missed some messages */
        NULL, /* completely unknown command */
        maim_parse_userinfo,
        maim_parse_search_address,
        maim_parse_search_name,
        maim_parse_search_fail,
        0x00
    };
    aim_register_callbacks(Maim_callbacks);
    return [super init];
}

- (void)initializeRunLoopCheck
{
    [NSTimer scheduledTimerWithTimeInterval:0.25 target:self selector:@selector(executeRunLoopCheck:) userInfo:nil repeats:YES];
    return;
}

- (void)executeRunLoopCheck:(NSTimer *)timer
{
   struct timeval	timeout;

    timeout.tv_sec = 0;
    timeout.tv_usec = 0;

        FD_ZERO(&errfds);
        FD_SET(aim_connection.fd, &errfds);
        FD_ZERO(&fds);
        FD_SET(aim_connection.fd, &fds);
        FD_SET(STDIN_FILENO, &fds);


    if(select((aim_connection.fd)+1, &fds, NULL, &errfds,
              &timeout) >= 0) {

        if (FD_ISSET(aim_connection.fd, &errfds)) {
            printf("Error detected on network socket :(\n");
#warning really need to flag a major error here
            return;
        }
        if (FD_ISSET(STDIN_FILENO, &fds)) {
        // getting key strokes
        //            gotkey(getch());
        }
        if (FD_ISSET(aim_connection.fd, &fds)) {
            aim_get_command();
            aim_rxdispatch();
        }
        if ([self commandToSend]) {
            aim_send_im([[self nextUser] cString],[[self nextMessage] cString]);
            [self setCommandToSend:NO];
        }    

        timeout.tv_sec = 0;
        timeout.tv_usec = 0;
        FD_ZERO(&fds);
        FD_SET(aim_connection.fd, &fds);
        FD_SET(STDIN_FILENO, &fds);
//        if (select((aim_connection.fd)+1, &fds, NULL, NULL,
//            &timeout) == 0) {
            // was updating naim windows here
            // doupdate();
//        }
        timeout.tv_sec = 0;
        timeout.tv_usec = 0;

        FD_ZERO(&errfds);
        FD_SET(aim_connection.fd, &errfds);
        FD_ZERO(&fds);
        FD_SET(aim_connection.fd, &fds);
        FD_SET(STDIN_FILENO, &fds);
    } else {
        [NSApp sendEvent:[NSApp currentEvent]];
    }    
}

- (void)handleIMPacket:(IMpack_t)packet
{
    return;
}

- (BOOL)commandToSend
{
    return commandToSend;
}

- (void)setCommandToSend:(BOOL)yn
{
    commandToSend = yn;
}

- (NSString *)nextUser
{
    return nextUser;
}

- (void)setNextUser:(NSString *)aName
{
    if (nextUser) [nextUser autorelease];
    nextUser = [aName retain];
    return;
}    

- (NSString *)nextMessage
{
    return nextMessage;
}

- (void)setNextMessage:(NSString *)aMessage
{
    if (nextMessage) [nextMessage autorelease];
    nextMessage = [aMessage retain];
    return;
}

- (void)sendIMToUser:(NSString *)userName message:(NSString *)message
{
    [self setNextUser:userName];
    [self setNextMessage:message];
    [self setCommandToSend:YES];
    return;
}    

@end
