/* GroupItem.m created by epeyton on Sat 27-Mar-1999 */

#import "GroupItem.h"

@implementation GroupItem

NSMutableDictionary *allGroups;

+ (void)initialize
{
    allGroups = [[NSMutableDictionary alloc] init];
    return;
}

+ (GroupItem *)groupNamed:(NSString *)aName
{
    return [allGroups objectForKey:aName];
}
  
- (void)dealloc
{
    [groupName release];
    [buddyNames release];
    [onlineBuddyNames release];
    [super dealloc];
}

- (id)initWithGroupName:(NSString *)aName
{
    
    self = [super init];
    [self setGroupName:aName];
    buddyNames = [[NSMutableArray alloc] init];
    onlineBuddyNames = [[NSMutableArray alloc] init];
    
    return self;
}

- (NSString *)description
{
    return [self groupName];
}    
    
- (void)setGroupName:(NSString *)aName
{
   	[groupName autorelease];
    groupName = [aName retain];
    return;
}

- (NSString *)groupName
{
    return [NSString stringWithFormat:@"%@ (%d/%d)",groupName, [[self onlineBuddyNames] count], [[self buddyNames] count]];
}

- (void)setBuddyNames:(NSArray *)anArray
{
    [buddyNames autorelease];
    buddyNames = [anArray retain];
    return;
}    

- (void)addToBuddyNames:(NSString *)aName
{
    [buddyNames addObject:aName];
}

- (void)removeFromBuddyNames:(NSString *)aName
{
    [buddyNames removeObject:aName];
}

- (NSArray *)buddyNames
{
    return buddyNames;
}

- (void)addToOnlineBuddyNames:(NSString *)aName
{
    [onlineBuddyNames addObject:aName];
}

- (void)removeFromOnlineBuddyNames:(NSString *)aName
{
    [onlineBuddyNames removeObject:aName];
}

- (NSArray *)onlineBuddyNames
{
    return onlineBuddyNames;
}


@end
