/* MainController.h created by epeyton on Tue 16-Mar-1999 */

#import <AppKit/AppKit.h>
#import "Fire.h"

@class ChatWindow;

@interface MainController : NSObject
{
    id 	communicationController;
    id 	loginController;
    id	buddyController;

    NSMutableDictionary *registrationDict;
    NSMutableDictionary *configDict;

    NSString		*myScreenName;
}

- (id)communicationController;
- (id)loginController;
- (id)buddyController;

- (NSDictionary *)configDict;

- (void)playSound:(NSString *)soundName;

- (NSString *)myScreenName;
- (void)setMyScreenName:(NSString *)aName;

- (void)newEmptyChatWindow:(id)sender;
- (void)newEmptyChatWindowForUser:(NSString *)userName;
- (void)chatWindowForUser:(NSString *)user withMessage:(NSString *)message;

- (void)registerChatWindow:(ChatWindow *)chatWindow;
- (void)unregisterChatWindow:(ChatWindow *)chatWindow;

- (void)completeLogin;

- (void)displayBuddyWindow:sender;

@end
