/* MainController.m created by epeyton on Tue 16-Mar-1999 */

#import "MainController.h"

@implementation MainController

// Initialization code
- (id)init
{
    self = [super init];
    registrationDict = [[NSMutableDictionary dictionary] retain];
    return self;
}
  
- (void)dealloc
{
    [communicationController release];
    [loginController release];
    [registrationDict release];
    [configDict release];
    [super dealloc];
    return;
}    

- (id)loginController { return loginController; }
- (id)communicationController { return communicationController; }
- (id)buddyController { return buddyController; }

- (void)playSound:(NSString *)soundName
{
    static NSSound *sound;

    if ([[NSUserDefaults standardUserDefaults] boolForKey:PLAY_SOUNDS]) {

    	if (![sound isPlaying]) {
        	[sound autorelease];

        	sound = [[NSSound alloc] initWithContentsOfFile:[[NSBundle mainBundle] pathForSoundResource:soundName] byReference:NO];
        
        	[sound play];
        }    
    }    
}

- (NSDictionary *)configDict
{
    if (!configDict) {
        //configDict = [[NSMutableDictionary dictionaryWithContentsOfFile:[[NSBundle mainBundle] pathForResource:CONFIG_FILE_NAME ofType:PLIST_EXTENSION]] retain];
        configDict = [[NSMutableDictionary dictionaryWithContentsOfFile:[NSString stringWithFormat:@"%@/%@.%@",NSHomeDirectory(),CONFIG_FILE_NAME, PLIST_EXTENSION]] retain];
    }    
    
	return configDict;
}    

- (NSString *)myScreenName
{
    return myScreenName;
}

- (void)setMyScreenName:(NSString *)aName
{
    myScreenName = [aName retain];
    return;
}    

- (void)newEmptyChatWindow:(id)sender
{
    [[ChatWindow alloc] init];
}

- (void)newEmptyChatWindowForUser:(NSString *)userName
{
    id cw = [[ChatWindow alloc] init];
    [cw setUser:userName];
    [self registerChatWindow:cw];
    [cw display];
}

- (void)chatWindowForUser:(NSString *)user withMessage:(NSString *)message
{
    ChatWindow *cw = nil;
    
    if (!(cw = [registrationDict objectForKey:user])) {
    	cw = [[[ChatWindow alloc] init] autorelease]; // the register also retains
    	[cw setUser:user];
        [[NSApp delegate] playSound:FIRST_MSG];
    } else {
        [[NSApp delegate] playSound:MSG_RECV];
    }
    
    [self registerChatWindow:cw];
    [cw addMessageToDisplay:message fromUser:user];

    [cw display];      
}    

- (void)applicationWillTerminate:(NSNotification *)aNotification 
{
    aim_logoff();
    return;
}

- (void)registerChatWindow:(ChatWindow *)chatWindow
{
    [registrationDict setObject:chatWindow forKey:[chatWindow user]];
    return;
}    

- (void)unregisterChatWindow:(ChatWindow *)chatWindow
{
    if ([chatWindow user]) {
    	[registrationDict removeObjectForKey:[chatWindow user]];
    }    
    return;
}

- (void)completeLogin
{
    static BOOL completed = NO;

    if (!completed) {
    	buddyController = [[BuddyController alloc] init];
        completed = YES;
    }    
    return;
}

- (void)displayBuddyWindow:sender
{
    [[buddyController window] makeKeyAndOrderFront:self];
}    

@end
